'' HAM RADIO QUESTION FLASHCARDS
'' BY JEFF LEDGER/OBC
'' V1.0
CON
  _clkmode = xtal1 + pll16x
  _xinfreq =5_000_000

  
  '' SD Configuration
  
   spiDO     = 3   ''************************************
   spiClk    = 2   ''** This configuration is for the  **
   spiDI     = 1   ''** PropModule by Ray Allen        ** 
   spiCS     = 0   ''************************************
   
OBJ

  text : "PSM_tv_text"
  sd:    "fsrwFemto"            ''SD Software used in FemtoBASIC

VAR

  long ioControl[2]             '' Variable required for SD Routines     
  byte buff[32]                 '' buffer for SD

  
PUB start | r,counter,tilda


  text.start
  TestMountSD  
  dira[6]~
  tilda:=0  
  sd.start(@ioControl)
  waitcnt(clkfreq + cnt)
  
  text.str(string(13," *** Technicians Class Amateur Radio **",13))
  text.str(string(13,"        PropModule Question Study:",13))
  text.str(string(13,"           By: Jeff Ledger/OBC",13,13,13,13,13,13))

  text.str(string(" INSTRUCTIONS:",13))
  text.str(string(" Use the button to review the correct",13))
  text.str(string(" answer & advance to the next question.",13,13,13))
  text.str(string(13,$C,1,"        Press the button to begin.      ",$C,8))
  repeat until ina[6] == 0                              '' Wait for button press
  text.out(0)
  waitcnt(clkfreq + cnt)
  sd.mount(spiDO,spiClk,spiDI,spiCS)                    '' Mount the SD


  
  r := sd.popen(string("question.txt"),"r") '' Open alpha.txt for read 
    repeat until r == -1 '' Start a loop until the end of the file is reached.
         r := sd.pgetc   '' Grap a single character
         if r > 10        '' If character is greater than nothing, display it.
             text.out(r)
             counter++
             
         if r == 13
            counter:=0

         if r == 32 and counter > 32 and counter < 40
            text.out(13)
            counter:=0

         if r == 126 and tilda == 0
           tilda:=1       

         elseif r == 126 and tilda == 1
           repeat until ina[6] == 0
           text.out(0)
           waitcnt(clkfreq + cnt)
           tilda:=0
           

           
           
  sd.unmount '' Unmount the SD

  sd.stop                                               'Stop the SD Routines
  
  text.str(string(13,"** Questions Finished",13))




PUB TestMountSD   ''SD Connection Test Routine
  
  sd.start(@ioControl)                                  'start the SD routines

  if \sd.mount(spiDO,spiClk,spiDI,spiCS) < 0         ''    SD Connection Startup
     text.str(string(13,"No SD card present.",13))   ''*****************************
     text.str(string("SD card expected on: P"))      ''** This SD startup routine **
     text.dec(spiDO)                                 ''** provides a gracefull    **
     text.str(string(", P"))                         ''** exit if something is    **
     text.dec(spiClk)                                ''** not connected properly  ** 
     text.str(string(", P"))                         ''** or if the card is       **
     text.dec(spiDI)                                 ''** unplugged.              **
     text.str(string(", P"))                         ''**                         **
     text.dec(spiCS)                                 ''** Code adapted from:      **
     text.str(string(13,13,"Program halted.",13))    ''** Mike Green              **
     abort                                           ''*****************************
  else
     text.str(string(13,"Connection to SD correctly established..",13))
     sd.unmount

  sd.stop        